const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const company_profiles = sequelize.define(
    'company_profiles',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      legal_name: {
        type: DataTypes.TEXT,
      },

      address: {
        type: DataTypes.TEXT,
      },

      phone: {
        type: DataTypes.TEXT,
      },

      email: {
        type: DataTypes.TEXT,
      },

      website: {
        type: DataTypes.TEXT,
      },

      rc: {
        type: DataTypes.TEXT,
      },

      ice: {
        type: DataTypes.TEXT,
      },

      patente: {
        type: DataTypes.TEXT,
      },

      logo_url: {
        type: DataTypes.TEXT,
      },

      pdf_footer: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  company_profiles.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.company_profiles.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.company_profiles.belongsTo(db.agences, {
      as: 'agences',
      foreignKey: {
        name: 'agencesId',
      },
      constraints: false,
    });

    db.company_profiles.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.company_profiles.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return company_profiles;
};
